// Keypress (int1) Handler
// Created 29/04/02; 00:47:15

#define USE_TI89              // Produce .89z File

#include <tigcclib.h>         // Include All Header Files
#include "keyboard.h"

INT_HANDLER oldint1 = NULL;  // will hold the address of the previous handler later
INT_HANDLER oldint4 = NULL;

DEFINE_INT_HANDLER (Getkey) 
{
	OSSetSR(0x0700);
	reset();
	sendos(getkey());
	OSSetSR(0x0000);
	ExecuteHandler(oldint1);
}

DEFINE_INT_HANDLER (myint4handler)
{

}

void _main(void)
{
	  if (oldint1) {
        //--------------------------------------------------
        // if TSR is already running (oldint1 != 0), stop it
        // by restoring the old interrupt vector
        //--------------------------------------------------
        SetIntVec(AUTO_INT_1, oldint1);
        oldint1 = NULL; // make sure that oldint1 is zero afterwards
    }
    else {
        //-----------------------------------------------------------
        // the TSR is not running till now
        // backup the old interrupt handler address in global oldint1
        // and install our own handler
        //-----------------------------------------------------------
        oldint1 = GetIntVec(AUTO_INT_1);
        SetIntVec(AUTO_INT_1, Getkey);
    }
   	if(oldint4) {
   			SetIntVec(AUTO_INT_4, oldint4);
   			oldint4 = NULL;
   	}
   	else {
   			oldint4=GetIntVec(AUTO_INT_4);
  			SetIntVec(AUTO_INT_4, myint4handler);
 		}
}
