// Keyboard Header
// Created 5/19/02

volatile unsigned char *point = (char *) 0x60000C;
volatile unsigned char *point2 = (char *) 0x60000E;
int shift=0,caps=0,key=0;

int lower[80]={
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,'`',0,
	0,0,0,0,0,'q','1',0,0,0,'z','s','a','w','2',0,
	0,'c','x','d','e','4','3',0,0,' ','v','f','t','r','5',0,
	0,'n','b','h','g','y','6',0,0,0,'m','j','u','7','8',0,
	0,',','k','i','o','0','9',0,0,'.','/','l',';','p','-',0,
};

int upper[80]={
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,'~',0,
	0,0,0,0,0,'Q','!',0,0,0,'Z','S','A','W','@',0,
	0,'C','X','D','E','$','#',0,0,' ','V','F','T','R','%',0,
	0,'N','B','H','G','Y','^',0,0,0,'M','J','U','&','*',0,
	0,'<','K','I','O',')','(',0,0,'>','?','L',':','P','_',0,
};

inline unsigned char read_SDA(void)
{
    return !(*point2 & 0x04);
}

inline unsigned char read_SCK(void)
{
    return !(*point2 & 0x08);
}

void SDA(char state)
{
    if (state == 0) *point2 |= 0x01;
    else *point2 &= 0xFE;
}

void SCK(char state)
{
    if (state == 0) *point2 |= 0x02;
    else *point2 &= 0xFD;
}

void delay(void)
{
    volatile int i, d = 1;
    for (i = 5; i > 0; --i) d *= 2;
}

inline void xdelay(int length)
{
	for(;length>0;length--) delay();
}
void reset(void)
{
    *point2 = 0x50;
    *point = 0x8D;
}

// waits if clock has given state
// also exits if a key of the first row (e.g. arrow keys) is pressed
inline void waitWhileSCK(int state)
{
    while (read_SCK() == state) {
	if (*(unsigned char *) 0x60001b != 0xff) break;
    }
}
///////////NO CHANGES ABOVE/////////////////////////////
unsigned char receiveByte(void)
{
    unsigned char buf = 0, d;
    //OSSetSR(0x0700);	//disable interrupts
    SCK(1);	//Enable keyb's clocks
    for (d = 100; d > 0; --d) {if (read_SCK() == 0)  break;}
    
    if (read_SCK())
    {
    	SCK(0);
    	//OSSetSR(0x0000); 
    	return 0;	//no new keystroke
    }
    waitWhileSCK(0);	// start bit
    for (d = 0; d < 8; ++d) {
			waitWhileSCK(1);
			if(read_SDA()) buf+=1<<d;
			waitWhileSCK(0);
    }
    waitWhileSCK(1);// parity bit
    waitWhileSCK(0);
    waitWhileSCK(1);// stop bit
    waitWhileSCK(0);
    SCK(0);	//disable keyb's clocks
    //OSSetSR(0x0000);	//re-enable interrupts
    return buf;
}

unsigned char waitbyte()
{
	unsigned char in=0;
	while(!in && key !=KEY_ESC)
	{
		in=receiveByte();
		OSdequeue(&key,kbd_queue());
	}
	return in;
}


int qwerty(unsigned char in)
{
	if(in != 240)	//make codes
	{
		if(in==0x12||in==0x59) shift=1;
		else if(in==0x58) caps=!caps;
		else if(in==0x5A) return KEY_ENTER;
		else if(in==0x66) return KEY_BACKSPACE;
		else if(in==0x76) return KEY_ESC;
		else if(in==0x75) return KEY_UP;
		else if(in==0x6B) return KEY_LEFT;
		else if(in==0x72) return KEY_DOWN;
		else if(in==0x74) return KEY_RIGHT;
		else if(in<80)
		{
			if(shift||caps) return upper[in];
			else return lower[in];
		}
		else return 0;
	}
	else		//break codes
	{
		in=waitbyte();
		if(in==0x12||in==0x59) shift=0;
		else if(in==0xF0) in=waitbyte();	//Arrow keys:2 break headers
		return 0;
	}
	return 0;	//just to shut compiler up
}

inline int getkey()
{
	return qwerty(receiveByte());
}

int waitkey()
{
	int in=0;
	while(!in)
	{
		in=waitbyte();
		if(key==KEY_ESC) break;
		in=qwerty(in);
	}
	return in;
}

inline void sendos(int in)
{
	if(in>0) OSenqueue(in,kbd_queue());
}




