//#define SAVE_SCREEN   

#include <tigcclib.h>
int _ti89, _ti92plus;  // produce code for TI89 and TI92plus
INT_HANDLER oldint6 = NULL;  // will hold the address of the previous handler later
LCD_BUFFER buffer;
//global variables:
//float currentnum;
char running=0;
long int current=0;
long int lparam=-1;
long int rparam=-1;
long int term=0;
char enter=0;
int op=1;
//int current_pos;
int yshift=40;
int xshift=15;
int top_on, topleft_on, topright_on, middle_on, bright_on, bleft_on, bottom_on;

//sprites
static unsigned char clear[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
static unsigned char bottom[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x7c,0xfe};
static unsigned char top[] = {0x00,0x00,0x00,0x00,0x00,0x00,0xfe,0x7c};
static unsigned char left[] = {0x80,0xc0,0xc0,0xc0,0xc0,0xc0,0x80,0x00};
static unsigned char right[] = {0x40,0xc0,0xc0,0xc0,0xc0,0xc0,0x40,0x00};
//static unsigned char dot[] = {0xc0,0xc0,0x00,0x00,0x00,0x00,0x00,0x00};

//functions:

void setbool(int num)
{
	if(num==1){
		top_on=0; topleft_on=0; topright_on=1; middle_on=0; bright_on=1; bleft_on=0; bottom_on=0;
	}
	if(num==2){
		top_on=1; topleft_on=0; topright_on=1; middle_on=1; bright_on=0; bleft_on=1; bottom_on=1;
	}
	if(num==3){
		top_on=1; topleft_on=0; topright_on=1; middle_on=1; bright_on=1; bleft_on=0; bottom_on=1;
	}
	if(num==4){
		top_on=0; topleft_on=1; topright_on=1; middle_on=1; bright_on=1; bleft_on=0; bottom_on=0;
	}
	if(num==5){
		top_on=1; topleft_on=1; topright_on=0; middle_on=1; bright_on=1; bleft_on=0; bottom_on=1;
	}
	if(num==6){
		top_on=1; topleft_on=1; topright_on=0; middle_on=1; bright_on=1; bleft_on=1; bottom_on=1;
	}
	if(num==7){
		top_on=1; topleft_on=1; topright_on=1; middle_on=0; bright_on=1; bleft_on=0; bottom_on=0;
	}
	if(num==8){
		top_on=1; topleft_on=1; topright_on=1; middle_on=1; bright_on=1; bleft_on=1; bottom_on=1;
	}
	if(num==9){
		top_on=1; topleft_on=1; topright_on=1; middle_on=1; bright_on=1; bleft_on=0; bottom_on=1;
	}
	if(num==0){
		top_on=1; topleft_on=1; topright_on=1; middle_on=0; bright_on=1; bleft_on=1; bottom_on=1;
	}
	if(num==13){
		top_on=1; topleft_on=1; topright_on=0; middle_on=1; bright_on=1; bleft_on=0; bottom_on=1;
	}
}

void drawc(int pos,int digit)
{
	pos=10-pos;
	setbool(digit);
	int y;
	int x;
	y=yshift;
	x=pos*11+xshift;
	if (top_on) Sprite8 (x+1, y-15, 8, top, LCD_MEM, SPRT_OR);
	if (topleft_on) Sprite8 (x, y-8, 8, left, LCD_MEM, SPRT_OR);
	if (topright_on) Sprite8 (x+7, y-8, 8, right, LCD_MEM, SPRT_OR);
	if (middle_on) {Sprite8 (x+1, y-8, 8, bottom, LCD_MEM, SPRT_OR);
									Sprite8 (x+1, y-7, 8, top, LCD_MEM, SPRT_OR);}
	if (bright_on) Sprite8 (x+7, y, 8, right, LCD_MEM, SPRT_OR);
	if (bleft_on) Sprite8 (x, y, 8, left, LCD_MEM, SPRT_OR);
	if (bottom_on) Sprite8(x+1, y, 8, bottom, LCD_MEM, SPRT_OR);
}

void draw_box()
{
	short y;
	for(y=yshift-12;y<yshift+9;y++)
	{
		DrawLine (xshift+7,y,xshift+121,y, A_REVERSE);
	}
	
	DrawLine (xshift+7, yshift+9, xshift+7, yshift-12, A_THICK1); 
	DrawLine (xshift+7, yshift+9, xshift+122, yshift+9, A_THICK1); 
	DrawLine (xshift+121, yshift+9, xshift+121, yshift-12, A_THICK1); 
	DrawLine (xshift+7, yshift-12, xshift+121, yshift-12, A_THICK1);
	
}

int digitize(short num)
{
	switch (num)
	{
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case '8': return 8;
		case '9': return 9;
		case '0': return 0;
	}
	return 11;
}

void display()
{
	draw_box();
	int n;
	long int t;
	t=current;
	for(n=0;n<10;n++)
	{
		drawc(n,t%10);
		t=(t-t%10)/10;
	}
}

void pressenter()
{
	if(lparam!=-1&&rparam!=-1)
	{
			term=rparam;
			if(op==1) current=lparam+rparam;
			else if(op==2)	current=lparam-rparam;
			else if(op==3) current=lparam*rparam;
			else if(op==4&&current!=0) current=lparam/rparam;
			lparam=current;
			display(); 
	}
}

void operator()
{
		enter=0;
		if(lparam==-1) lparam=current; // first try to load left side
		else if(rparam==-1) {  //load right side if left is empty
			rparam=current;
			pressenter();
			rparam=-1;
		}
		else{							//if both are full, continue operation
			pressenter();
			rparam=-1;
		}
		current=0;
}

void inout()
{//get input, perform calculations, and output answer
	short key;
	int new;
	do
	{
		key=ngetchx();
		new=digitize(key);
		if(new!=11){
			current=current*10+new;
			display();
		}
		if(key=='+'){
			operator();
			op=1;
		}
		if(key=='-'){
			operator();
			op=2;
		}
		if(key=='*'){
			operator();
			op=3;
		}
		if(key=='/'){
			operator();
			op=4;
		}
		if(key==KEY_CLEAR){
			enter=0;
			lparam=-1;
			rparam=-1;
			current=0;
			op=1;
			display();
		}
		if(key==KEY_BACKSPACE){
			current=(current-current%10)/10;
			display();
		}
		if(key==KEY_ENTER){
			if(enter==0)
			{
				rparam=current;
				term=rparam;
				pressenter();
				lparam=-1;
				rparam=-1;
			}
			else
			{
				lparam=current;
				rparam=term;
				pressenter();
				rparam=-1;
				lparam=-1;
			}
			enter=1;
		}
	}
	while(key!=KEY_ESC);
}

void start(void)
{
  current=0;
  lparam=-1;
  rparam=-1;
  op=1;
	draw_box();
	display();
	inout();
}

DEFINE_INT_HANDLER (myint6handler) {  


		//OSSetSR(0x0700);//turn off ints. - our prog wont run on top of itself
		if(_rowread(~0b1) & 0b1000000)
		//            ^ masks everything but row one
		//                     ^ ands with bit 6 (diamond)
		{
				if(running!=33)
				{
				running=33;
		 		LCD_save(buffer);
				start();	//diamond and on are held down: go for it
				LCD_restore(buffer);

				ST_modKey(ST_NONE);
				short x,y;
				for(x=43;x<50;x++)
				{
					for(y=95;y<101;y++)
					{
						DrawPix(x,y,A_REVERSE);
					}
				}
				running=0;
				//OSSetSR(0x0000);//turn ints back on
				}
		}
    else 
    {
    //OSSetSR(0x0000);//turn ints back on
    ExecuteHandler(oldint6); //only press on if our routine is not going to go
    }
}


//this is called when install program is called
void _main(void) {
    if (oldint6) {
        SetIntVec(AUTO_INT_6, oldint6);
        oldint6 = NULL; // make sure that oldint6 is zero afterwards
    }
    else {
        oldint6 = GetIntVec(AUTO_INT_6);
        SetIntVec(AUTO_INT_6, myint6handler);
    }
}



